/*
 * Copyright (C) 2002 Robert Ernst <robert.ernst@linux-solutions.at>
 *
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file LICENSE.GPL included in the
 * packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See COPYING for GPL licensing information.
 *
 */

#include <qwidget.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qimage.h>
#include <qpainter.h>
#include "SpriteCollection.h"
#include "images/data.c"

SpriteCollection::SpriteCollection(QWidget *parent)
{
    m_parent = parent;
    m_board.loadFromData(board_data_, sizeof (board_data_));
    m_empty.loadFromData(empty_data_, sizeof (empty_data_));
    m_red.loadFromData(red_data_, sizeof (red_data_));
    m_red.setMask(m_red.createHeuristicMask());
    m_yellow.loadFromData(yellow_data_, sizeof (yellow_data_));
    m_yellow.setMask(m_yellow.createHeuristicMask());
}

void SpriteCollection::drawBoard(QPainter &painter, int x, int y)
{
    painter.drawPixmap(x, y, m_board);
}

void SpriteCollection::drawEmpty(QPainter &painter, int x, int y)
{
    painter.drawPixmap(x, y, m_empty);
}

void SpriteCollection::drawRed(QPainter &painter, int x, int y)
{
    painter.drawPixmap(x, y, m_red);
}

void SpriteCollection::drawYellow(QPainter &painter, int x, int y)
{
    painter.drawPixmap(x, y, m_yellow);
}

