/*
 * Copyright (C) 2002 Robert Ernst <robert.ernst@linux-solutions.at>
 *
 * This file may be distributed and/or modified under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation and appearing in the file LICENSE.GPL included in the
 * packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See COPYING for GPL licensing information.
 *
 */

#ifndef __SPRITECOLLECTION_HEADER__
#define __SPRITECOLLECTION_HEADER__

#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>

class SpriteCollection
{
public:
    SpriteCollection(QWidget *parent);

private:
    QPixmap m_board;
    QPixmap m_empty;
    QPixmap m_red;
    QPixmap m_yellow;
    QWidget *m_parent;

public:
    void drawBoard(QPainter &painter, int x, int y);
    void drawEmpty(QPainter &painter, int x, int y);
    void drawRed(QPainter &painter, int x, int y);
    void drawYellow(QPainter &painter, int x, int y);
};

#endif // __SPRITECOLLECTION_HEADER__

